<?php
/**
 * InlineResponse20061ContentCompanies
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20061ContentCompanies Class Doc Comment
 *
 * @category Class
 * @description object containing a found company with all associated infos
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20061ContentCompanies implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_61_content_companies';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'name' => 'string',
        'street' => 'string',
        'postCode' => 'string',
        'city' => 'string',
        'country' => 'string',
        'displayId' => 'string',
        'phoneNumber' => 'string',
        'faxNumber' => 'string',
        'email' => 'string',
        'website' => 'string',
        'inactive' => 'bool',
        'lockout' => 'bool',
        'centralType' => 'string',
        'personalCustomer' => 'bool',
        'mobileNumber' => 'string',
        'privateNumber' => 'string',
        'types' => 'object[]',
        'anticipatedCallbacks' => '\SLIS\Adapter\Tanss\Model\InlineResponse20061ContentAnticipatedCallbacks[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'name' => null,
        'street' => null,
        'postCode' => null,
        'city' => null,
        'country' => null,
        'displayId' => null,
        'phoneNumber' => null,
        'faxNumber' => null,
        'email' => null,
        'website' => null,
        'inactive' => null,
        'lockout' => null,
        'centralType' => null,
        'personalCustomer' => null,
        'mobileNumber' => null,
        'privateNumber' => null,
        'types' => null,
        'anticipatedCallbacks' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'name' => 'name',
        'street' => 'street',
        'postCode' => 'postCode',
        'city' => 'city',
        'country' => 'country',
        'displayId' => 'displayId',
        'phoneNumber' => 'phoneNumber',
        'faxNumber' => 'faxNumber',
        'email' => 'email',
        'website' => 'website',
        'inactive' => 'inactive',
        'lockout' => 'lockout',
        'centralType' => 'centralType',
        'personalCustomer' => 'personalCustomer',
        'mobileNumber' => 'mobileNumber',
        'privateNumber' => 'privateNumber',
        'types' => 'types',
        'anticipatedCallbacks' => 'anticipatedCallbacks'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'name' => 'setName',
        'street' => 'setStreet',
        'postCode' => 'setPostCode',
        'city' => 'setCity',
        'country' => 'setCountry',
        'displayId' => 'setDisplayId',
        'phoneNumber' => 'setPhoneNumber',
        'faxNumber' => 'setFaxNumber',
        'email' => 'setEmail',
        'website' => 'setWebsite',
        'inactive' => 'setInactive',
        'lockout' => 'setLockout',
        'centralType' => 'setCentralType',
        'personalCustomer' => 'setPersonalCustomer',
        'mobileNumber' => 'setMobileNumber',
        'privateNumber' => 'setPrivateNumber',
        'types' => 'setTypes',
        'anticipatedCallbacks' => 'setAnticipatedCallbacks'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'name' => 'getName',
        'street' => 'getStreet',
        'postCode' => 'getPostCode',
        'city' => 'getCity',
        'country' => 'getCountry',
        'displayId' => 'getDisplayId',
        'phoneNumber' => 'getPhoneNumber',
        'faxNumber' => 'getFaxNumber',
        'email' => 'getEmail',
        'website' => 'getWebsite',
        'inactive' => 'getInactive',
        'lockout' => 'getLockout',
        'centralType' => 'getCentralType',
        'personalCustomer' => 'getPersonalCustomer',
        'mobileNumber' => 'getMobileNumber',
        'privateNumber' => 'getPrivateNumber',
        'types' => 'getTypes',
        'anticipatedCallbacks' => 'getAnticipatedCallbacks'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const CENTRAL_TYPE_NONE = 'NONE';
    public const CENTRAL_TYPE_CENTRAL = 'CENTRAL';
    public const CENTRAL_TYPE_BRANCH = 'BRANCH';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getCentralTypeAllowableValues()
    {
        return [
            self::CENTRAL_TYPE_NONE,
            self::CENTRAL_TYPE_CENTRAL,
            self::CENTRAL_TYPE_BRANCH,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['street'] = $data['street'] ?? null;
        $this->container['postCode'] = $data['postCode'] ?? null;
        $this->container['city'] = $data['city'] ?? null;
        $this->container['country'] = $data['country'] ?? null;
        $this->container['displayId'] = $data['displayId'] ?? null;
        $this->container['phoneNumber'] = $data['phoneNumber'] ?? null;
        $this->container['faxNumber'] = $data['faxNumber'] ?? null;
        $this->container['email'] = $data['email'] ?? null;
        $this->container['website'] = $data['website'] ?? null;
        $this->container['inactive'] = $data['inactive'] ?? null;
        $this->container['lockout'] = $data['lockout'] ?? null;
        $this->container['centralType'] = $data['centralType'] ?? null;
        $this->container['personalCustomer'] = $data['personalCustomer'] ?? null;
        $this->container['mobileNumber'] = $data['mobileNumber'] ?? null;
        $this->container['privateNumber'] = $data['privateNumber'] ?? null;
        $this->container['types'] = $data['types'] ?? null;
        $this->container['anticipatedCallbacks'] = $data['anticipatedCallbacks'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getCentralTypeAllowableValues();
        if (!is_null($this->container['centralType']) && !in_array($this->container['centralType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'centralType', must be one of '%s'",
                $this->container['centralType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id fo the company
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name name of the company
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets street
     *
     * @return string|null
     */
    public function getStreet()
    {
        return $this->container['street'];
    }

    /**
     * Sets street
     *
     * @param string|null $street street of the company
     *
     * @return self
     */
    public function setStreet($street)
    {
        $this->container['street'] = $street;

        return $this;
    }

    /**
     * Gets postCode
     *
     * @return string|null
     */
    public function getPostCode()
    {
        return $this->container['postCode'];
    }

    /**
     * Sets postCode
     *
     * @param string|null $postCode postal code of the company
     *
     * @return self
     */
    public function setPostCode($postCode)
    {
        $this->container['postCode'] = $postCode;

        return $this;
    }

    /**
     * Gets city
     *
     * @return string|null
     */
    public function getCity()
    {
        return $this->container['city'];
    }

    /**
     * Sets city
     *
     * @param string|null $city city of the company
     *
     * @return self
     */
    public function setCity($city)
    {
        $this->container['city'] = $city;

        return $this;
    }

    /**
     * Gets country
     *
     * @return string|null
     */
    public function getCountry()
    {
        return $this->container['country'];
    }

    /**
     * Sets country
     *
     * @param string|null $country country of the company
     *
     * @return self
     */
    public function setCountry($country)
    {
        $this->container['country'] = $country;

        return $this;
    }

    /**
     * Gets displayId
     *
     * @return string|null
     */
    public function getDisplayId()
    {
        return $this->container['displayId'];
    }

    /**
     * Sets displayId
     *
     * @param string|null $displayId display if (customer nr.)
     *
     * @return self
     */
    public function setDisplayId($displayId)
    {
        $this->container['displayId'] = $displayId;

        return $this;
    }

    /**
     * Gets phoneNumber
     *
     * @return string|null
     */
    public function getPhoneNumber()
    {
        return $this->container['phoneNumber'];
    }

    /**
     * Sets phoneNumber
     *
     * @param string|null $phoneNumber phone number
     *
     * @return self
     */
    public function setPhoneNumber($phoneNumber)
    {
        $this->container['phoneNumber'] = $phoneNumber;

        return $this;
    }

    /**
     * Gets faxNumber
     *
     * @return string|null
     */
    public function getFaxNumber()
    {
        return $this->container['faxNumber'];
    }

    /**
     * Sets faxNumber
     *
     * @param string|null $faxNumber fax number
     *
     * @return self
     */
    public function setFaxNumber($faxNumber)
    {
        $this->container['faxNumber'] = $faxNumber;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email e-Mail of the company
     *
     * @return self
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets website
     *
     * @return string|null
     */
    public function getWebsite()
    {
        return $this->container['website'];
    }

    /**
     * Sets website
     *
     * @param string|null $website website of the company
     *
     * @return self
     */
    public function setWebsite($website)
    {
        $this->container['website'] = $website;

        return $this;
    }

    /**
     * Gets inactive
     *
     * @return bool|null
     */
    public function getInactive()
    {
        return $this->container['inactive'];
    }

    /**
     * Sets inactive
     *
     * @param bool|null $inactive if the company is incative, info is given here
     *
     * @return self
     */
    public function setInactive($inactive)
    {
        $this->container['inactive'] = $inactive;

        return $this;
    }

    /**
     * Gets lockout
     *
     * @return bool|null
     */
    public function getLockout()
    {
        return $this->container['lockout'];
    }

    /**
     * Sets lockout
     *
     * @param bool|null $lockout defines, if the company is locked (n service may be entered)
     *
     * @return self
     */
    public function setLockout($lockout)
    {
        $this->container['lockout'] = $lockout;

        return $this;
    }

    /**
     * Gets centralType
     *
     * @return string|null
     */
    public function getCentralType()
    {
        return $this->container['centralType'];
    }

    /**
     * Sets centralType
     *
     * @param string|null $centralType defines, if a company is a central, or a branch (or none of it)
     *
     * @return self
     */
    public function setCentralType($centralType)
    {
        $allowedValues = $this->getCentralTypeAllowableValues();
        if (!is_null($centralType) && !in_array($centralType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'centralType', must be one of '%s'",
                    $centralType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['centralType'] = $centralType;

        return $this;
    }

    /**
     * Gets personalCustomer
     *
     * @return bool|null
     */
    public function getPersonalCustomer()
    {
        return $this->container['personalCustomer'];
    }

    /**
     * Sets personalCustomer
     *
     * @param bool|null $personalCustomer defines if the company is a \"private customer\"
     *
     * @return self
     */
    public function setPersonalCustomer($personalCustomer)
    {
        $this->container['personalCustomer'] = $personalCustomer;

        return $this;
    }

    /**
     * Gets mobileNumber
     *
     * @return string|null
     */
    public function getMobileNumber()
    {
        return $this->container['mobileNumber'];
    }

    /**
     * Sets mobileNumber
     *
     * @param string|null $mobileNumber mobile phone number (only if its a private customer)
     *
     * @return self
     */
    public function setMobileNumber($mobileNumber)
    {
        $this->container['mobileNumber'] = $mobileNumber;

        return $this;
    }

    /**
     * Gets privateNumber
     *
     * @return string|null
     */
    public function getPrivateNumber()
    {
        return $this->container['privateNumber'];
    }

    /**
     * Sets privateNumber
     *
     * @param string|null $privateNumber private phone number (only if its a private customer)
     *
     * @return self
     */
    public function setPrivateNumber($privateNumber)
    {
        $this->container['privateNumber'] = $privateNumber;

        return $this;
    }

    /**
     * Gets types
     *
     * @return object[]|null
     */
    public function getTypes()
    {
        return $this->container['types'];
    }

    /**
     * Sets types
     *
     * @param object[]|null $types types
     *
     * @return self
     */
    public function setTypes($types)
    {
        $this->container['types'] = $types;

        return $this;
    }

    /**
     * Gets anticipatedCallbacks
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20061ContentAnticipatedCallbacks[]|null
     */
    public function getAnticipatedCallbacks()
    {
        return $this->container['anticipatedCallbacks'];
    }

    /**
     * Sets anticipatedCallbacks
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20061ContentAnticipatedCallbacks[]|null $anticipatedCallbacks anticipatedCallbacks
     *
     * @return self
     */
    public function setAnticipatedCallbacks($anticipatedCallbacks)
    {
        $this->container['anticipatedCallbacks'] = $anticipatedCallbacks;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


